DEFINE VARIABLE sp-companyCode        AS CHARACTER NO-UNDO INITIAL 'EUC'.
DEFINE VARIABLE lCreateMissingVoyCntr AS LOGICAL   NO-UNDO INITIAL YES.
DEFINE VARIABLE iCntr                 AS INTEGER   NO-UNDO.
DEFINE VARIABLE iCorrupt              AS INTEGER   NO-UNDO.
DEFINE VARIABLE lVsslCorrupt          AS LOGICAL   NO-UNDO.
DEFINE BUFFER b-ca-u_voyage_container FOR ca-u_voyage_container.

FORM iCorrupt
     iCntr
     ca-u_shipment.bookingnr 
     lVsslCorrupt  COLUMN-LABEL 'key!corrupt'
     ca-u_shipment_item_container.shipment_seqnr
     ca-u_shipment_item_container.item_seqnr 
     ca-u_shipment_item_container.containerprefix 
     ca-u_shipment_item_container.containerNr FORMAT '999999/9'
     WITH FRAME a
          WIDTH 140 
          40 DOWN
          VIEW-AS DIALOG-BOX.

PAUSE 2 BEFORE-HIDE MESSAGE "Pausing 2 seconds".

cntr:
FOR EACH ca-u_shipment_item_container EXCLUSIVE-LOCK WHERE
         ca-u_shipment_item_container.companycode EQ sp-companyCode,
   FIRST ca-u_shipment NO-LOCK WHERE 
         ca-u_shipment.companycode EQ sp-companyCode AND
         ca-u_shipment.shipment_seqnr EQ ca-u_shipment_item_container.shipment_seqnr:
   iCntr = iCntr + 1.
   
   PROCESS EVENTS.  
   
   lVsslCorrupt = ca-u_shipment.vesselnr NE ca-u_shipment_item_container.vesselnr.
   IF lVsslCorrupt THEN DO:
      ca-u_shipment_item_container.vesselnr = ca-u_shipment.vesselnr.
      DISPLAY 
         iCntr
         ca-u_shipment.bookingnr 
         lVsslCorrupt
         ca-u_shipment_item_container.shipment_seqnr
         ca-u_shipment_item_container.item_seqnr 
         ca-u_shipment_item_container.containerprefix
         ca-u_shipment_item_container.containerNr 
         WITH FRAME a.
      DOWN WITH FRAME a.   
   END. /* lVsslCorrupt */
   
   IF CAN-FIND(FIRST ca-u_voyage_container WHERE 
                     ca-u_voyage_container.companycode     EQ sp-companyCode AND
                     ca-u_voyage_container.vesselnr        EQ ca-u_shipment.vesselNr AND
                     ca-u_voyage_container.inward-outward  EQ 'o' AND
                     ca-u_voyage_container.containerprefix EQ ca-u_shipment_item_container.containerprefix AND
                     ca-u_voyage_container.containernr     EQ ca-u_shipment_item_container.containernr) THEN
      NEXT cntr.                 
   
   iCorrupt = iCorrupt + 1.
   
   DISPLAY iCorrupt
           iCntr
           ca-u_shipment.bookingnr 
           ca-u_shipment_item_container.shipment_seqnr
           ca-u_shipment_item_container.item_seqnr 
           ca-u_shipment_item_container.containerprefix
           ca-u_shipment_item_container.containerNr
           WITH FRAME a.
   DOWN WITH FRAME a.
   
   IF NOT lCreateMissingVoyCntr THEN 
      NEXT cntr.
   
   CREATE ca-u_voyage_container.
   ASSIGN ca-u_voyage_container.companycode      = sp-companyCode
          ca-u_voyage_container.vesselnr         = ca-u_shipment.vesselnr
          ca-u_voyage_container.container        = YES
          ca-u_voyage_container.containerprefix  = ca-u_shipment_item_container.containerPrefix
          ca-u_voyage_container.containernr      = ca-u_shipment_item_container.containernr
          ca-u_voyage_container.inward-outward   = 'o'
          ca-u_voyage_container.remarks          = 'Regenerated by sofpak due to missing master record.'.
   
   /*-- item data --*/
   FOR FIRST ca-u_shipment_item NO-LOCK WHERE 
             ca-u_shipment_item.companycode    EQ sp-companyCode AND
             ca-u_shipment_item.shipment_seqnr EQ ca-u_shipment_item_container.shipment_seqnr AND
             ca-u_shipment_item.item_seqnr     EQ ca-u_shipment_item_container.item_seqnr:
      ASSIGN 
         ca-u_voyage_container.overheight       = ca-u_shipment_item.overheight
         ca-u_voyage_container.overlength_back  = ca-u_shipment_item.overlength_back
         ca-u_voyage_container.overlength_front = ca-u_shipment_item.overlength_front
         ca-u_voyage_container.overwidth_left   = ca-u_shipment_item.overwidth_left
         ca-u_voyage_container.overwidth_right  = ca-u_shipment_item.overwidth_right
         ca-u_voyage_container.reefer_temp1     = ca-u_shipment_item.reefer_temp1
         ca-u_voyage_container.reefer_temp2     = ca-u_shipment_item.reefer_temp2
         ca-u_voyage_container.typeCode         = ca-u_shipment_item.containertypecode.
   END. /* u_ship_item */
   
   /*-- EC data --*/
   FOR FIRST ec-container NO-LOCK WHERE 
             ec-container.companycode     EQ sp-companyCode AND
             ec-container.containerprefix EQ ca-u_shipment_item_container.containerprefix AND
             ec-container.containernr     EQ ca-u_shipment_item_container.containernr AND
             ec-container.bookingnr       EQ ca-u_shipment.bookingnr:
      ASSIGN 
         ca-u_voyage_container.typeCode = ec-container.typecode 
         ca-u_voyage_container.sealno   = ec-container.sealno
         ca-u_voyage_container.tare     = ec-container.tare.
   END. /* ec-container */
   
   /*-- indien er geen voyage_container beschikbaar is voor deze voyage, dan kijken we in het verleden 
        of deze container al eens is gebruikt en halen daar wat gegevens vandaan --*/
   IF ca-u_voyage_container.typeCode EQ '' OR ca-u_voyage_container.typeCode EQ ? THEN
      FOR FIRST b-ca-u_voyage_container NO-LOCK WHERE 
                b-ca-u_voyage_container.companyCode     EQ sp-companycode AND 
                b-ca-u_voyage_container.inward-outward  EQ 'o' AND 
                b-ca-u_voyage_container.containerPrefix EQ ca-u_shipment_item_container.containerprefix AND 
                b-ca-u_voyage_container.containerNr     EQ ca-u_shipment_item_container.containerNr AND 
                b-ca-u_voyage_container.typeCode        NE ? AND 
                b-ca-u_voyage_container.typeCode        NE '':
         ca-u_voyage_container.typeCode = b-ca-u_voyage_container.typeCode.
         IF ca-u_voyage_container.tare EQ ? 
         OR ca-u_voyage_container.tare EQ 0 THEN
            ca-u_voyage_container.tare = b-ca-u_voyage_container.tare.
      END. /* b-voy_cntr */
   
   /*-- leaseCode is empty --*/
   FOR FIRST b-ca-u_voyage_container NO-LOCK WHERE 
             b-ca-u_voyage_container.companyCode     EQ sp-companycode AND 
             b-ca-u_voyage_container.inward-outward  EQ 'o' AND 
             b-ca-u_voyage_container.containerPrefix EQ ca-u_shipment_item_container.containerPrefix AND 
             b-ca-u_voyage_container.containerNr     EQ ca-u_shipment_item_container.containerNr AND 
             b-ca-u_voyage_container.leaseCode       NE ? AND 
             b-ca-u_voyage_container.leaseCode       NE '':
      ca-u_voyage_container.leasecode = b-ca-u_voyage_container.leaseCode.
      IF ca-u_voyage_container.tare EQ ? 
      OR ca-u_voyage_container.tare EQ 0 THEN
         ca-u_voyage_container.tare = b-ca-u_voyage_container.tare.
   END. /* b-voy_cntr */ 
     
   /*-- Tare --*/
   IF ca-u_voyage_container.tare EQ ? 
   OR ca-u_voyage_container.tare EQ 0 THEN
      FOR FIRST aa-container_type NO-LOCK WHERE 
                aa-container_type.companycode EQ sp-companycode AND 
                aa-container_type.typecode    EQ ca-u_voyage_container.typeCode:
         ca-u_voyage_container.tare = aa-container_type.tare.
      END.

/*    ASSIGN ca-u_voyage_container.dt_release         */
/*           ca-u_voyage_container.dt_release_valid   */
/*           ca-u_voyage_container.release_messageno  */
/*           ca-u_voyage_container.release_pincode    */
/*           ca-u_voyage_container.release_usercode   */
/*           ca-u_voyage_container.stackcode          */
/*           ca-u_voyage_container.statuscode         */
/*           ca-u_voyage_container.stowagecode        */
/*           ca-u_voyage_container.stowage_location   */
/*           ca-u_voyage_container.stowage_regulation */
      
END. /* u_ship_itm_cntr */
MESSAGE 'done'
SKIP iCorrupt 'missing voy_cntr records on' iCntr 'containers'.
